#include "EntityPersonDialog.hpp"
#include "resource.h"


BEGIN_MESSAGE_MAP(CEntityPersonDialog, CDialog)

END_MESSAGE_MAP()


////////////////////////////////////////////////////////////////////////////////

CEntityPersonDialog::CEntityPersonDialog(sPersonEntity& person)
: CDialog(IDD_ENTITY_PERSON)
, m_Person(person)
{
}

////////////////////////////////////////////////////////////////////////////////

BOOL
CEntityPersonDialog::OnInitDialog()
{
  // initialize controls
  
  SendDlgItemMessage(IDC_MOVEMENT, CB_ADDSTRING, 0, (LPARAM)"None");
  SendDlgItemMessage(IDC_MOVEMENT, CB_ADDSTRING, 0, (LPARAM)"Random");
  SendDlgItemMessage(IDC_MOVEMENT, CB_ADDSTRING, 0, (LPARAM)"Repeated");
  
  // put in the initial values
  
  SetDlgItemText(IDC_NAME,      m_Person.name.c_str());
  SetDlgItemText(IDC_SPRITESET, m_Person.spriteset.c_str());

  SendDlgItemMessage(IDC_MOVEMENT, CB_SETCURSEL, m_Person.movement_type);
  SetDlgItemInt(IDC_WALK_SPEED,    m_Person.walk_speed);
  SetDlgItemInt(IDC_WALK_DURATION, m_Person.walk_duration);
  SetDlgItemInt(IDC_WALK_DELAY,    m_Person.walk_delay);

  CheckDlgButton(m_Person.dialogue_type == sPersonEntity::FILE ? IDC_FILE : IDC_TEXT, BST_CHECKED);
  SetDlgItemText(IDC_DIALOGUE, m_Person.dialogue.c_str());

  // give spriteset edit box focus
  GetDlgItem(IDC_NAME)->SetFocus();
  return FALSE;
}

////////////////////////////////////////////////////////////////////////////////

void
CEntityPersonDialog::OnOK()
{
  // store the data back into the entity
  char str[4096];

  GetDlgItemText(IDC_NAME, str, 4096);
  m_Person.name = str;

  GetDlgItemText(IDC_SPRITESET, str, 4096);
  m_Person.spriteset = str;

  m_Person.movement_type = SendDlgItemMessage(IDC_MOVEMENT, CB_GETCURSEL);
  m_Person.walk_speed    = GetDlgItemInt(IDC_WALK_SPEED);
  m_Person.walk_duration = GetDlgItemInt(IDC_WALK_DURATION);
  m_Person.walk_delay    = GetDlgItemInt(IDC_WALK_DELAY);

  m_Person.dialogue_type = (IsDlgButtonChecked(IDC_FILE) == BST_CHECKED ? sPersonEntity::FILE : sPersonEntity::TEXT);
  GetDlgItemText(IDC_DIALOGUE, str, 4096);
  m_Person.dialogue = str;

  CDialog::OnOK();
}

////////////////////////////////////////////////////////////////////////////////
