#include <stdio.h>
#include <string.h>
#include "FileServer.hpp"

///////////////////////////////////////////////////////////////////////////////

CFileServer::CFileServer()
: m_PackageActive(false)
{
}

///////////////////////////////////////////////////////////////////////////////

CFileServer::CFileServer(bool LoadFromPackageOnly)
{
  m_LoadFromPackageOnly = LoadFromPackageOnly;
}

///////////////////////////////////////////////////////////////////////////////

CFileServer::~CFileServer()
{
}

///////////////////////////////////////////////////////////////////////////////

void
CFileServer::LoadSPK(const char* filename)
{
  m_PackageActive = m_Files.Load(filename);
}

///////////////////////////////////////////////////////////////////////////////

FILE*
CFileServer::GetFile(const char* filename)
{
  if (m_PackageActive)
    if (m_Files.GetFile(filename) != NULL)
      return m_Files.GetFile(filename);

  FILE* file;
  file = fopen(filename, "rb");

  return file;
}

///////////////////////////////////////////////////////////////////////////////

long
CFileServer::GetFileLength(const char* filename)
{
  if (m_PackageActive)
    if (m_Files.GetFile(filename) != NULL)
      return m_Files.GetFileLength(filename);


  FILE* file;
  long len;

  file = fopen(filename, "rb");

  if (file == NULL)
    return 0;

  fseek(file, 0, SEEK_END);
  len = ftell(file);
  fclose(file);

  return len;
}

///////////////////////////////////////////////////////////////////////////////