#include <stdio.h>
#include <stdlib.h>
#include "render.h"
#include "video.h"
#include "timer.h"


////////////////////////////////////////////////////////////////////////////////

void ClearScreen(void)
{
  ApplyColorMask(rgbaBlack);
}

////////////////////////////////////////////////////////////////////////////////

void FadeIn(unsigned msecs)
{
  FadeFromColor(msecs, rgbaBlack);
}

////////////////////////////////////////////////////////////////////////////////

void FadeOut(unsigned msecs)
{
  FadeToColor(msecs, rgbaBlack);
}

////////////////////////////////////////////////////////////////////////////////

void FadeToColor(unsigned msecs, RGBA color)
{
  IMAGE image = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());

  dword time = GetTime();
  while (GetTime() - time < msecs)
  {
    color.alpha = (byte)((GetTime() - time) * 255 / msecs);
    BlitImage(image, 0, 0);
    ApplyColorMask(color);
    FlipScreen();
  }

  DestroyImage(image);
}

////////////////////////////////////////////////////////////////////////////////

void FadeFromColor(unsigned msecs, RGBA color)
{
  IMAGE image = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());

  dword time = GetTime();
  while (GetTime() - time < msecs)
  {
    color.alpha = 255 - (byte)((GetTime() - time) * 255 / msecs);
    BlitImage(image, 0, 0);
    ApplyColorMask(color);
    FlipScreen();
  }

  DestroyImage(image);
}

////////////////////////////////////////////////////////////////////////////////
