#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "simage.hpp"
#include "Image32.hpp"


////////////////////////////////////////////////////////////////////////////////

IMAGE SLoadImage(FILE* file)
{
  if (file == NULL)
    return NULL;

  CImage32 image;
  if (!image.LoadFromFile(file))
  {
    fclose(file);
    return NULL;
  }

  fclose(file);
  return CreateImage(image.GetWidth(), image.GetHeight(), image.GetPixels());
}

////////////////////////////////////////////////////////////////////////////////

IMAGE SLoadImageScale(FILE* file, int width, int height)
{
  if (file == NULL)
    return NULL;

  CImage32 image;
  if (!image.LoadFromFile(file))
  {
    fclose(file);
    return NULL;
  }

  fclose(file);

  image.Rescale(width, height);
  return CreateImage(image.GetWidth(), image.GetHeight(), image.GetPixels());
}

////////////////////////////////////////////////////////////////////////////////
